/*
 File: subrule_def.cpp
 Date and Time: Fri Jan 30 18:55:24 2015 
*/
#include "subrule_def.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_subrule_def;// grammar's ns
// first set terminals
fsm_rules_reuse_table_type::fsm_rules_reuse_table_type(){
 no_rules_entries_ = 36;
 per_rule_s_table_[0] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[1] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[2] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[3] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[4] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[5] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[6] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[7] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[8] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[9] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[10] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[11] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[12] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[13] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[14] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[15] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[16] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[17] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[18] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[19] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[20] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[21] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[22] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[23] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[24] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[25] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[26] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[27] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[28] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[29] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[30] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[31] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[32] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[33] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[34] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[35] =  new Per_rule_s_reuse_table();
}
  Csubrule_def::
  Csubrule_def()
    :yacco2::CAbs_fsm
      ("subrule_def.lex"
      ,"1.0"
      ,"24 mar 2004"
      ,true
      ,"Parse a subrule: into the valley of sin..."
      ,"Fri Jan 30 18:55:24 2015 "
      ,S1_Csubrule_def){
    
      subrule_def_ = 0;
  
  }
 
Csubrule_def::~Csubrule_def(){

  for(int x = 0;x < 36;++x){
   ///delete fsm_rules_reuse_table.per_rule_s_table_[x];
  }
} 

  bool Csubrule_def::failed(){
      return false;
  }
  void Csubrule_def::op(){
    if(subrule_def_ != 0){
      delete subrule_def_;
      subrule_def_ = 0;
    }
    subrule_def_ = new T_subrule_def;
    subrule_def_->set_rc(*parser__->start_token__,__FILE__,__LINE__);
  
}
int Csubrule_def::rhs_to_rules_mapping_[78] = {
 -1
 ,0 // subrule 1 for rule 1
 ,1 // subrule 2 for rule 2
 ,2 // subrule 3 for rule 3
 ,3 // subrule 4 for rule 4
 ,3 // subrule 5 for rule 4
 ,3 // subrule 6 for rule 4
 ,3 // subrule 7 for rule 4
 ,3 // subrule 8 for rule 4
 ,4 // subrule 9 for rule 5
 ,5 // subrule 10 for rule 6
 ,6 // subrule 11 for rule 7
 ,6 // subrule 12 for rule 7
 ,6 // subrule 13 for rule 7
 ,6 // subrule 14 for rule 7
 ,7 // subrule 15 for rule 8
 ,7 // subrule 16 for rule 8
 ,8 // subrule 17 for rule 9
 ,9 // subrule 18 for rule 10
 ,9 // subrule 19 for rule 10
 ,9 // subrule 20 for rule 10
 ,10 // subrule 21 for rule 11
 ,10 // subrule 22 for rule 11
 ,10 // subrule 23 for rule 11
 ,11 // subrule 24 for rule 12
 ,11 // subrule 25 for rule 12
 ,11 // subrule 26 for rule 12
 ,12 // subrule 27 for rule 13
 ,13 // subrule 28 for rule 14
 ,14 // subrule 29 for rule 15
 ,14 // subrule 30 for rule 15
 ,15 // subrule 31 for rule 16
 ,15 // subrule 32 for rule 16
 ,16 // subrule 33 for rule 17
 ,16 // subrule 34 for rule 17
 ,17 // subrule 35 for rule 18
 ,17 // subrule 36 for rule 18
 ,17 // subrule 37 for rule 18
 ,18 // subrule 38 for rule 19
 ,18 // subrule 39 for rule 19
 ,18 // subrule 40 for rule 19
 ,19 // subrule 41 for rule 20
 ,19 // subrule 42 for rule 20
 ,19 // subrule 43 for rule 20
 ,20 // subrule 44 for rule 21
 ,20 // subrule 45 for rule 21
 ,21 // subrule 46 for rule 22
 ,21 // subrule 47 for rule 22
 ,22 // subrule 48 for rule 23
 ,23 // subrule 49 for rule 24
 ,23 // subrule 50 for rule 24
 ,24 // subrule 51 for rule 25
 ,25 // subrule 52 for rule 26
 ,25 // subrule 53 for rule 26
 ,25 // subrule 54 for rule 26
 ,26 // subrule 55 for rule 27
 ,26 // subrule 56 for rule 27
 ,27 // subrule 57 for rule 28
 ,27 // subrule 58 for rule 28
 ,28 // subrule 59 for rule 29
 ,28 // subrule 60 for rule 29
 ,29 // subrule 61 for rule 30
 ,29 // subrule 62 for rule 30
 ,30 // subrule 63 for rule 31
 ,31 // subrule 64 for rule 32
 ,31 // subrule 65 for rule 32
 ,32 // subrule 66 for rule 33
 ,32 // subrule 67 for rule 33
 ,33 // subrule 68 for rule 34
 ,33 // subrule 69 for rule 34
 ,34 // subrule 70 for rule 35
 ,34 // subrule 71 for rule 35
 ,34 // subrule 72 for rule 35
 ,34 // subrule 73 for rule 35
 ,35 // subrule 74 for rule 36
 ,35 // subrule 75 for rule 36
 ,35 // subrule 76 for rule 36
 ,35 // subrule 77 for rule 36
}; 

    void Csubrule_def::
    add_sdc_to_directive(yacco2::CAbs_lr1_sym* Dir,T_syntax_code* Sdc){
      using namespace NS_yacco2_T_enum;
      using namespace NS_yacco2_terminals;
      yacco2::INT eid = Dir->enumerated_id__;
      switch (eid){
		case T_Enum::T_T_op_: {
		  T_op* k = (T_op*)Dir;
		  k->syntax_code(Sdc);
		  break;
		}      
		default: {
          CAbs_lr1_sym* sym = new Err_improper_directive;
          sym->set_rc(*Dir,__FILE__,__LINE__);
          
          RSVP_FSM(sym);
          parser__->set_stop_parse(true);
   		}      
      }    
    }
  
Rsubrule_def::Rsubrule_def(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rsubrule_def",0,Csubrule_def::R_Rsubrule_def_,P,false,false){
}

void Rsubrule_def::sr1(){
  
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
      fsm->subrule_def_->bld_its_tree();
      RSVP(fsm->subrule_def_);
      fsm->subrule_def_ = 0;
    
}

Rvector::Rvector(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rvector",0,Csubrule_def::R_Rvector_,P,false,false){
}

Rcommon_comments::Rcommon_comments(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rcommon_comments",0,Csubrule_def::R_Rcommon_comments_,P,false,false){
}

yacco2::THR _YACCO2_CALL_TYPE
NS_subrule_def::AR_Rrhs_expr(yacco2::Parser* Caller_pp){
 yacco2::KCHARP ar_name = "AR_Rrhs_expr";
#include "war_begin_code.h"
 
    using namespace NS_yacco2_T_enum;
  for(i=1;i<=ie;++i){
    CAbs_lr1_sym* sym = Caller_pp->pp_accept_queue__[i].accept_token__;
   if(sym->enumerated_id__ == NS_yacco2_T_enum::T_Enum::T_LR1_parallel_operator_){
        goto arbitrated_parameter;
   }
   if(sym->enumerated_id__ == NS_yacco2_T_enum::T_Enum::T_LR1_fset_transience_operator_){
        goto arbitrated_parameter;
   }
  }
  
#include "war_end_code.h"
}

Rrhs_expr::Rrhs_expr(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rrhs_expr",0,Csubrule_def::R_Rrhs_expr_,P,false,false){
}

yacco2::THR _YACCO2_CALL_TYPE
NS_subrule_def::AR_Rstart_thread(yacco2::Parser* Caller_pp){
 yacco2::KCHARP ar_name = "AR_Rstart_thread";
#include "war_begin_code.h"
 
    using namespace NS_yacco2_T_enum;
  for(i=1;i<=ie;++i){
    CAbs_lr1_sym* sym = Caller_pp->pp_accept_queue__[i].accept_token__;
   if(sym->enumerated_id__ == NS_yacco2_T_enum::T_Enum::T_LR1_parallel_operator_){
        goto arbitrated_parameter;
   }
   if(sym->enumerated_id__ == NS_yacco2_T_enum::T_Enum::T_LR1_fset_transience_operator_){
        goto arbitrated_parameter;
   }
  }
  
#include "war_end_code.h"
}

Rstart_thread::Rstart_thread(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rstart_thread",0,Csubrule_def::R_Rstart_thread_,P,false,false){
}

void Rstart_thread::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   LR1_parallel_operator* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
        T_sym_tbl_report_card report_card;
        using namespace yacco2_stbl;
        find_sym_in_stbl(report_card,*sf->p2__->id__);
        if(report_card.action_ == T_sym_tbl_report_card::not_fnd){
          CAbs_lr1_sym* sym = new Err_subrule_use_undefined_T;
          sym->set_rc(*rule_info__.parser__->start_token__,__FILE__,__LINE__);
          RSVP(sym);
          rule_info__.parser__->set_stop_parse(true); 
          return; 
        }
        CAbs_lr1_sym* sym = report_card.tbl_entry_->symbol_;
        T_in_stbl* t = (T_in_stbl*)sym;
        refered_T* rT = *(t->xref_t()->rbegin());
      fsm->subrule_def_->add_elem_to_subrule_vector(rT);
      rT->its_subrule_def(fsm->subrule_def_);
    
}

Rbal_thread_expr::Rbal_thread_expr(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rbal_thread_expr",0,Csubrule_def::R_Rbal_thread_expr_,P,false,false){
}

Rrtned_T::Rrtned_T(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rrtned_T",0,Csubrule_def::R_Rrtned_T_,P,false,false){
}

void Rrtned_T::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_in_stbl* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
      refered_T* reft = *(sf->p2__->xref_t()->rbegin());
      fsm->subrule_def_->add_elem_to_subrule_vector(reft);
      reft->its_subrule_def(fsm->subrule_def_);
    
}

void Rrtned_T::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      CAbs_lr1_sym* sym = new Err_not_T_for_rtned_token_from_th();
      sym->set_rc(*sf->p2__,__FILE__,__LINE__);
      RSVP(sym);
      rule_info__.parser__->set_stop_parse(true);       
    
}

void Rrtned_T::sr3(){
  struct SF{
   CAbs_lr1_sym* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(1);
  
      CAbs_lr1_sym* sym = new Err_not_T_for_rtned_token_from_th();
      sym->set_rc(*sf->p1__,__FILE__,__LINE__);
      RSVP(sym);
      rule_info__.parser__->set_stop_parse(true);       
    
}

void Rrtned_T::sr4(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   LR1_parallel_operator* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
      fsm->subrule_def_->add_elem_to_subrule_vector(sf->p2__);
    
}

Rcalled_thread::Rcalled_thread(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rcalled_thread",0,Csubrule_def::R_Rcalled_thread_,P,false,false){
}

void Rcalled_thread::sr1(){
  struct SF{
   Rns* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   Rdbl_colon* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
   Rth_name* p3__;
   State* s3__;
   bool abort3__;
   Rule_s_reuse_entry* rule_s_reuse_entry3__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(3);
  
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
      T_called_thread_eosubrule* sym = 
		new T_called_thread_eosubrule(sf->p1__->ns_,sf->p3__->thd_nm_); 
      sym->set_rc(*sf->p1__->ns_,__FILE__,__LINE__);
      sym->its_subrule_def(fsm->subrule_def_);
      fsm->subrule_def_->add_elem_to_subrule_vector(sym);
  
}

RNULL::RNULL(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("RNULL",0,Csubrule_def::R_RNULL_,P,false,false){
}

void RNULL::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_NULL* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
      T_null_call_thread_eosubrule* sym = new T_null_call_thread_eosubrule;
      sym->set_rc(*sf->p2__,__FILE__,__LINE__);
      sym->its_subrule_def(fsm->subrule_def_);
      fsm->subrule_def_->add_elem_to_subrule_vector(sym);
      sf->p2__->set_auto_delete(true);
    
}

Rns::Rns(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rns",0,Csubrule_def::R_Rns_,P,false,false){
}

void Rns::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_identifier* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      ns_ = sf->p2__;
    
}

void Rns::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      CAbs_lr1_sym* sym = new Err_not_id_for_ns_in_th_stmt();
      sym->set_rc(*sf->p2__,__FILE__,__LINE__);
      RSVP(sym);
      rule_info__.parser__->set_stop_parse(true);       
    
}

void Rns::sr3(){
  struct SF{
   CAbs_lr1_sym* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(1);
  
      CAbs_lr1_sym* sym = new Err_not_id_for_ns_in_th_stmt();
      sym->set_rc(*sf->p1__,__FILE__,__LINE__);
      RSVP(sym);
      rule_info__.parser__->set_stop_parse(true);       
    
}

Rdbl_colon::Rdbl_colon(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rdbl_colon",0,Csubrule_def::R_Rdbl_colon_,P,false,false){
}

void Rdbl_colon::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_2colon* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      sf->p2__->set_auto_delete(true);
    
}

void Rdbl_colon::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      CAbs_lr1_sym* sym = new Err_not_dbl_colon_in_th_stmt();
      sym->set_rc(*sf->p2__,__FILE__,__LINE__);
      RSVP(sym);
      rule_info__.parser__->set_stop_parse(true);       
    
}

void Rdbl_colon::sr3(){
  struct SF{
   CAbs_lr1_sym* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(1);
  
      CAbs_lr1_sym* sym = new Err_not_dbl_colon_in_th_stmt();
      sym->set_rc(*sf->p1__,__FILE__,__LINE__);
      RSVP(sym);
      rule_info__.parser__->set_stop_parse(true);       
    
}

Rth_name::Rth_name(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rth_name",0,Csubrule_def::R_Rth_name_,P,false,false){
}

void Rth_name::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_identifier* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      thd_nm_ = sf->p2__;
    
}

void Rth_name::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      CAbs_lr1_sym* sym = new Err_not_id_for_th_name_in_th_stmt();
      sym->set_rc(*sf->p2__,__FILE__,__LINE__);
      RSVP(sym);
      rule_info__.parser__->set_stop_parse(true);       
    
}

void Rth_name::sr3(){
  struct SF{
   CAbs_lr1_sym* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(1);
  
      CAbs_lr1_sym* sym = new Err_not_id_for_th_name_in_th_stmt();
      sym->set_rc(*sf->p1__,__FILE__,__LINE__);
      RSVP(sym);
      rule_info__.parser__->set_stop_parse(true);       
    
}

yacco2::THR _YACCO2_CALL_TYPE
NS_subrule_def::AR_Rcalled_proc_op(yacco2::Parser* Caller_pp){
 yacco2::KCHARP ar_name = "AR_Rcalled_proc_op";
#include "war_begin_code.h"
 
    using namespace NS_yacco2_T_enum;
  for(i=1;i<=ie;++i){
   if(Caller_pp->pp_accept_queue__[i].accept_token__->enumerated_id__ 
             == NS_yacco2_T_enum::T_Enum::T_LR1_parallel_operator_){
        goto arbitrated_parameter;
   }
   if(Caller_pp->pp_accept_queue__[i].accept_token__->enumerated_id__ 
             == NS_yacco2_T_enum::T_Enum::T_LR1_fset_transience_operator_){
        goto arbitrated_parameter;
   }
  }
  
#include "war_end_code.h"
}

Rcalled_proc_op::Rcalled_proc_op(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rcalled_proc_op",0,Csubrule_def::R_Rcalled_proc_op_,P,false,false){
}

void Rcalled_proc_op::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   LR1_fset_transience_operator* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
        T_sym_tbl_report_card report_card;
        using namespace yacco2_stbl;
        find_sym_in_stbl(report_card,*sf->p2__->id__);
        if(report_card.action_ == T_sym_tbl_report_card::not_fnd){
          CAbs_lr1_sym* sym = new Err_subrule_use_undefined_T;
          sym->set_rc(*rule_info__.parser__->start_token__,__FILE__,__LINE__);
          RSVP(sym);
          rule_info__.parser__->set_stop_parse(true); 
          return; 
        }
        CAbs_lr1_sym* sym = report_card.tbl_entry_->symbol_;
        T_in_stbl* t = (T_in_stbl*)sym;
        refered_T* rT = *(t->xref_t()->rbegin());
      fsm->subrule_def_->add_elem_to_subrule_vector(rT);
      rT->its_subrule_def(fsm->subrule_def_);
    
}

Rbal_called_proc_expr::Rbal_called_proc_expr(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rbal_called_proc_expr",0,Csubrule_def::R_Rbal_called_proc_expr_,P,false,false){
}

Rcalled_proc_name::Rcalled_proc_name(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rcalled_proc_name",0,Csubrule_def::R_Rcalled_proc_name_,P,false,false){
}

void Rcalled_proc_name::sr1(){
  struct SF{
   Rns* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   Rdbl_colon* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
   Rth_name* p3__;
   State* s3__;
   bool abort3__;
   Rule_s_reuse_entry* rule_s_reuse_entry3__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(3);
  
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
      T_called_thread_eosubrule* sym = 
		new T_called_thread_eosubrule(sf->p1__->ns_,sf->p3__->thd_nm_); 
      sym->set_rc(*sf->p1__->ns_,__FILE__,__LINE__);
      sym->its_subrule_def(fsm->subrule_def_);
      fsm->subrule_def_->add_elem_to_subrule_vector(sym);
  
}

RTorRcomponents_epi::RTorRcomponents_epi(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("RTorRcomponents_epi",0,Csubrule_def::R_RTorRcomponents_epi_,P,false,false){
}

RTorRcomponents::RTorRcomponents(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("RTorRcomponents",0,Csubrule_def::R_RTorRcomponents_,P,false,false){
}

RTorRcomponent::RTorRcomponent(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("RTorRcomponent",0,Csubrule_def::R_RTorRcomponent_,P,false,false){
}

void RTorRcomponent::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   rule_in_stbl* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
      refered_rule* refr = *(sf->p2__->xref_r()->rbegin());
      fsm->subrule_def_->add_elem_to_subrule_vector(refr);
      refr->its_subrule_def(fsm->subrule_def_);
    
}

void RTorRcomponent::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_in_stbl* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
      refered_T* reft = *(sf->p2__->xref_t()->rbegin());
      fsm->subrule_def_->add_elem_to_subrule_vector(reft);
      reft->its_subrule_def(fsm->subrule_def_);
    
}

void RTorRcomponent::sr3(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      CAbs_lr1_sym* sym = new Err_not_T_or_R_in_subrule_expr();
      sym->set_rc(*sf->p2__,__FILE__,__LINE__);
      RSVP(sym);
      rule_info__.parser__->set_stop_parse(true);       
    
}

Rchained_dispatcher::Rchained_dispatcher(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rchained_dispatcher",0,Csubrule_def::R_Rchained_dispatcher_,P,false,false){
}

void Rchained_dispatcher::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   rule_in_stbl* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
      refered_rule* refr = *(sf->p2__->xref_r()->rbegin());
      fsm->subrule_def_->add_elem_to_subrule_vector(refr);
      refr->its_subrule_def(fsm->subrule_def_);
    
}

void Rchained_dispatcher::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_in_stbl* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
      CAbs_lr1_sym* sym = new Err_not_a_Rule();
      sym->set_rc(*sf->p2__,__FILE__,__LINE__);
      RSVP(sym);
      rule_info__.parser__->set_stop_parse(true);       
    
}

void Rchained_dispatcher::sr3(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      CAbs_lr1_sym* sym = new Err_not_a_Rule();
      sym->set_rc(*sf->p2__,__FILE__,__LINE__);
      RSVP(sym);
      rule_info__.parser__->set_stop_parse(true);       
    
}

Rmust_eos::Rmust_eos(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rmust_eos",0,Csubrule_def::R_Rmust_eos_,P,false,false){
}

void Rmust_eos::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_eosubrule* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
      fsm->subrule_def_->add_elem_to_subrule_vector(sf->p2__);
      sf->p2__->its_subrule_def(fsm->subrule_def_);
    
}

void Rmust_eos::sr2(){
  struct SF{
   CAbs_lr1_sym* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(1);
  
      CAbs_lr1_sym* sym = new Err_not_eos_in_subrule_expr();
      sym->set_rc(*sf->p1__,__FILE__,__LINE__);
      RSVP(sym);
      rule_info__.parser__->set_stop_parse(true);       
    
}

void Rmust_eos::sr3(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      CAbs_lr1_sym* sym = new Err_not_eos_in_subrule_expr();
      sym->set_rc(*sf->p2__,__FILE__,__LINE__);
      RSVP(sym);
      rule_info__.parser__->set_stop_parse(true);       
      sf->p2__->set_auto_delete(true);
    
}

Rcalled_thd_eos::Rcalled_thd_eos(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rcalled_thd_eos",0,Csubrule_def::R_Rcalled_thd_eos_,P,false,false){
}

void Rcalled_thd_eos::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_eosubrule* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
      fsm->subrule_def_->add_elem_to_subrule_vector(sf->p2__);
      sf->p2__->its_subrule_def(fsm->subrule_def_);
    
}

void Rcalled_thd_eos::sr2(){
  struct SF{
   CAbs_lr1_sym* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(1);
  
      CAbs_lr1_sym* sym = new Err_not_eos_in_subrule_expr();
      sym->set_rc(*sf->p1__,__FILE__,__LINE__);
      RSVP(sym);
      rule_info__.parser__->set_stop_parse(true);       
    
}

Rcalled_proc_eos::Rcalled_proc_eos(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rcalled_proc_eos",0,Csubrule_def::R_Rcalled_proc_eos_,P,false,false){
}

void Rcalled_proc_eos::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_eosubrule* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
      fsm->subrule_def_->add_elem_to_subrule_vector(sf->p2__);
      sf->p2__->its_subrule_def(fsm->subrule_def_);
    
}

void Rcalled_proc_eos::sr2(){
  struct SF{
   CAbs_lr1_sym* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(1);
  
      CAbs_lr1_sym* sym = new Err_not_eos_in_subrule_expr();
      sym->set_rc(*sf->p1__,__FILE__,__LINE__);
      RSVP(sym);
      rule_info__.parser__->set_stop_parse(true);       
    
}

Rpotential_codeblk::Rpotential_codeblk(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rpotential_codeblk",0,Csubrule_def::R_Rpotential_codeblk_,P,false,false){
}

Rpotential_directives::Rpotential_directives(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rpotential_directives",0,Csubrule_def::R_Rpotential_directives_,P,false,false){
}

Rmust_directive_phrase::Rmust_directive_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rmust_directive_phrase",0,Csubrule_def::R_Rmust_directive_phrase_,P,false,false){
}

void Rmust_directive_phrase::sr1(){
  struct SF{
   Rdirective_cweb_k_epi* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   Rlint_epi* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
   Rmust_directive* p3__;
   State* s3__;
   bool abort3__;
   Rule_s_reuse_entry* rule_s_reuse_entry3__;
   Rsyntax_code* p4__;
   State* s4__;
   bool abort4__;
   Rule_s_reuse_entry* rule_s_reuse_entry4__;
   Rlint_epi* p5__;
   State* s5__;
   bool abort5__;
   Rule_s_reuse_entry* rule_s_reuse_entry5__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(5);
  
      AST* cwebt = sf->p1__->cweb_t_;
      Rmust_directive* dir = sf->p3__;
      Rsyntax_code* sdc = sf->p4__;
      if(cwebt != 0){
        sdc->syntax_code_->add_cweb_marker(cwebt);
				}
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
      fsm->add_sdc_to_directive(dir->directive_,sdc->syntax_code_);
    
}

Rmust_directive::Rmust_directive(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rmust_directive",0,Csubrule_def::R_Rmust_directive_,P,false,false){
}

void Rmust_directive::op(){
  sstrace_rulesss
 
    if(directive_ == 0) return;
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
    CAbs_lr1_sym* result = 
	fsm->subrule_def_->add_directive_to_subrule(directive_,rule_info__.parser__);
    if(result == 0) return;// ok added
    directive_->set_auto_delete(true);//dup: delete when popped from stack
    RSVP(result);
    rule_info__.parser__->set_stop_parse(true);
  
}
void Rmust_directive::ctor(){
 
    directive_ = 0;
  
}
void Rmust_directive::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_op* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      directive_ = sf->p2__;
    
}

void Rmust_directive::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
	directive_ = 0;
        sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_bad_directive;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

void Rmust_directive::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_directive_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rclose_brace::Rclose_brace(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rclose_brace",0,Csubrule_def::R_Rclose_brace_,P,false,false){
}

void Rclose_brace::sr1(){
  
        CAbs_lr1_sym* sym = new Err_no_close_brace;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rmaybe_more_directives::Rmaybe_more_directives(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rmaybe_more_directives",0,Csubrule_def::R_Rmaybe_more_directives_,P,false,false){
}

Rmaybe_directive_phrases::Rmaybe_directive_phrases(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rmaybe_directive_phrases",0,Csubrule_def::R_Rmaybe_directive_phrases_,P,false,false){
}

Rmaybe_directive_phrase::Rmaybe_directive_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rmaybe_directive_phrase",0,Csubrule_def::R_Rmaybe_directive_phrase_,P,false,false){
}

void Rmaybe_directive_phrase::sr1(){
  struct SF{
   Rdirective_cweb_k_epi* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   Rlint_epi* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
   Rdirective* p3__;
   State* s3__;
   bool abort3__;
   Rule_s_reuse_entry* rule_s_reuse_entry3__;
   Rsyntax_code* p4__;
   State* s4__;
   bool abort4__;
   Rule_s_reuse_entry* rule_s_reuse_entry4__;
   Rlint_epi* p5__;
   State* s5__;
   bool abort5__;
   Rule_s_reuse_entry* rule_s_reuse_entry5__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(5);
  
      AST* cwebt = sf->p1__->cweb_t_;
      Rdirective* dir = sf->p3__;
      Rsyntax_code* sdc = sf->p4__;
      if(cwebt != 0){
        sdc->syntax_code_->add_cweb_marker(cwebt);
				}

      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
      fsm->add_sdc_to_directive(dir->directive_,sdc->syntax_code_);
    
}

void Rmaybe_directive_phrase::sr2(){
  struct SF{
   Rdirective* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   Rsyntax_code* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
   Rlint_epi* p3__;
   State* s3__;
   bool abort3__;
   Rule_s_reuse_entry* rule_s_reuse_entry3__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(3);
  
      Rdirective* dir = sf->p1__;
      Rsyntax_code* sdc = sf->p2__;
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
      fsm->add_sdc_to_directive(dir->directive_,sdc->syntax_code_);
    
}

Rdirective_phrase::Rdirective_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rdirective_phrase",0,Csubrule_def::R_Rdirective_phrase_,P,false,false){
}

void Rdirective_phrase::sr1(){
  struct SF{
   Rlint_epi* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   Rdirective_cweb_k_epi* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
   Rlint_epi* p3__;
   State* s3__;
   bool abort3__;
   Rule_s_reuse_entry* rule_s_reuse_entry3__;
   Rdirective* p4__;
   State* s4__;
   bool abort4__;
   Rule_s_reuse_entry* rule_s_reuse_entry4__;
   Rsyntax_code* p5__;
   State* s5__;
   bool abort5__;
   Rule_s_reuse_entry* rule_s_reuse_entry5__;
   Rlint_epi* p6__;
   State* s6__;
   bool abort6__;
   Rule_s_reuse_entry* rule_s_reuse_entry6__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(6);
  
      AST* cwebt = sf->p2__->cweb_t_;
      Rdirective* dir = sf->p4__;
      Rsyntax_code* sdc = sf->p5__;
      if(cwebt != 0){
        sdc->syntax_code_->add_cweb_marker(cwebt);
				}
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
      fsm->add_sdc_to_directive(dir->directive_,sdc->syntax_code_);
    
}

Rdirective::Rdirective(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rdirective",0,Csubrule_def::R_Rdirective_,P,false,false){
}

void Rdirective::op(){
  sstrace_rulesss
 
    if(directive_ == 0) return;
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
    CAbs_lr1_sym* result = 
		fsm->subrule_def_->add_directive_to_subrule(directive_,rule_info__.parser__);
    if(result == 0) return;// ok added
    directive_->set_auto_delete(true);//dup: delete when popped from stack
    RSVP(result);
    rule_info__.parser__->set_stop_parse(true);
  
}
void Rdirective::ctor(){
 
    directive_ = 0;
  
}
void Rdirective::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_op* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      directive_ = sf->p2__;
    
}

void Rdirective::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
	directive_ = 0;
        sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_bad_directive;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rsyntax_code::Rsyntax_code(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rsyntax_code",0,Csubrule_def::R_Rsyntax_code_,P,false,false){
}

void Rsyntax_code::ctor(){
 
	  syntax_code_ = 0;
	
}
void Rsyntax_code::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_syntax_code* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        syntax_code_ = sf->p2__;
      
}

void Rsyntax_code::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        RSVP(sf->p2__);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rlint_epi::Rlint_epi(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rlint_epi",0,Csubrule_def::R_Rlint_epi_,P,false,false){
}

Rdirective_cweb_k_epi::Rdirective_cweb_k_epi(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rdirective_cweb_k_epi",0,Csubrule_def::R_Rdirective_cweb_k_epi_,P,false,false){
}

void Rdirective_cweb_k_epi::ctor(){
 
	  cweb_t_ = 0;
	
}
void Rdirective_cweb_k_epi::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_cweb_comment* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        T_cweb_comment* k = sf->p2__;
        AST* cwebk_t_ = new AST(*k);
        cweb_t_ = new AST();
        T_cweb_marker* cw = new T_cweb_marker(cweb_t_);
        cw->set_rc(*k,__FILE__,__LINE__);
        AST::join_pts(*cweb_t_,*cwebk_t_);
        AST::set_content(*cweb_t_,*cw);
	
}

void Rdirective_cweb_k_epi::sr3(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   Err_comment_overrun* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
   
		RSVP(sf->p2__);
		rule_info__.parser__->set_stop_parse(true); 
      
}

void Rdirective_cweb_k_epi::sr4(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_comment* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
   
        sf->p2__->set_auto_delete(true);
      
}

Rcweb_k_epi::Rcweb_k_epi(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rcweb_k_epi",0,Csubrule_def::R_Rcweb_k_epi_,P,false,false){
}

void Rcweb_k_epi::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_cweb_comment* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      Csubrule_def* fsm = (Csubrule_def*)rule_info__.parser__->fsm_tbl__;
        T_cweb_comment* k = sf->p2__;
        AST* cwebk_t_ = new AST(*k);
        AST* cweb_t_ = new AST();
        T_cweb_marker* cw = new T_cweb_marker(cweb_t_);
        cw->set_rc(*k,__FILE__,__LINE__);
        AST::join_pts(*cweb_t_,*cwebk_t_);

        AST::set_content(*cweb_t_,*cw);
        fsm->subrule_def_->add_cweb_marker(cweb_t_);
	
}

void Rcweb_k_epi::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   Err_comment_overrun* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
   
		RSVP(sf->p2__);
		rule_info__.parser__->set_stop_parse(true); 
      
}

void Rcweb_k_epi::sr3(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_comment* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
   
        sf->p2__->set_auto_delete(true);
      
}

